## mozjs60 60.2.3

=== js/src/wasm/Makefile ===
.PHONY: help update run expectations

help:
	@echo "Script to regenerate wasm test cases (JS and WPT) from the spec repository."
	@echo ""
	@echo "- a spec directory is needed under js/src/wasm (not checked in). It can be a"
	@echo "  symbolic link or a real directory; if it's not there, the Makefile will clone"
	@echo "  the repository from the sources."
	@echo "- 'make update' makes sure the spec wast interpreter is up to date, regenerates"
	@echo "  all the JS and WPT test cases, and put them in the right directories, then"
	@echo "  updates the WPT manifest, if needed."
	@echo "- 'MOZCONFIG=/path/to/bin/firefox make run' runs the WPT test cases and prints a"
	@echo "  summary of the failures in the console."
	@echo "- 'MOZCONFIG=/path/to/bin/firefox make expectations' runs the WPT test cases and"
	@echo "  updates the expectations (known failures)."
	@echo ""
	@echo "Choose a rule: update or expectations."

update:
	[ -d ./spec ] || git clone https://github.com/webassembly/spec ./spec
	(cd ./spec/interpreter && make)
	./spec/test/build.py \
		--js ../jit-test/tests/wasm/spec \
		--html ../../../testing/web-platform/mozilla/tests/wasm
	echo "|jit-test| test-also-wasm-baseline; include:wasm-testharness.js" > ../jit-test/tests/wasm/spec/directives.txt
	../../../mach wpt-manifest-update

run:
	@[ -z $(MOZCONFIG) ] && echo "You need to define the MOZCONFIG env variable first."
	@[ -z $(MOZCONFIG) ] || ../../../mach wpt /_mozilla/wasm

expectations:
	@[ -z $(MOZCONFIG) ] && echo "You need to define the MOZCONFIG env variable first." || true
	@[ -z $(MOZCONFIG) ] || ../../../mach wpt /_mozilla/wasm --log-raw /tmp/expectations.log || true
	@[ -z $(MOZCONFIG) ] || ../../../mach wpt-update /tmp/expectations.log --no-patch

=== third_party/python/psutil/Makefile ===
# Shortcuts for various tasks (UNIX only).
# To use a specific Python version run: "make install PYTHON=python3.3"
# You can set the variables below from the command line.

PYTHON = python
TSCRIPT = psutil/tests/__main__.py
ARGS =
# List of nice-to-have dev libs.
DEPS = \
	argparse \
	check-manifest \
	coverage \
	flake8 \
	futures \
	ipaddress \
	mock==1.0.1 \
	pep8 \
	perf \
	pyflakes \
	requests \
	setuptools \
	sphinx \
	twine \
	unittest2 \
	wheel

# In not in a virtualenv, add --user options for install commands.
INSTALL_OPTS = `$(PYTHON) -c "import sys; print('' if hasattr(sys, 'real_prefix') else '--user')"`
TEST_PREFIX = PYTHONWARNINGS=all PSUTIL_TESTING=1 PSUTIL_DEBUG=1

all: test

# ===================================================================
# Install
# ===================================================================

clean:  ## Remove all build files.
	rm -rf `find . -type d -name __pycache__ \
		-o -type f -name \*.bak \
		-o -type f -name \*.orig \
		-o -type f -name \*.pyc \
		-o -type f -name \*.pyd \
		-o -type f -name \*.pyo \
		-o -type f -name \*.rej \
		-o -type f -name \*.so \
		-o -type f -name \*.~ \
		-o -type f -name \*\$testfn`
	rm -rf \
		*.core \
		*.egg-info \
		*\$testfn* \
		.coverage \
		.tox \
		build/ \
		dist/ \
		docs/_build/ \
		htmlcov/ \
		tmp/

_:

build: _  ## Compile without installing.
	# make sure setuptools is installed (needed for 'develop' / edit mode)
	$(PYTHON) -c "import setuptools"
	PYTHONWARNINGS=all $(PYTHON) setup.py build
	@# copies compiled *.so files in ./psutil directory in order to allow
	@# "import psutil" when using the interactive interpreter from within
	@# this directory.
	PYTHONWARNINGS=all $(PYTHON) setup.py build_ext -i
	rm -rf tmp
	$(PYTHON) -c "import psutil"  # make sure it actually worked

install:  ## Install this package as current user in "edit" mode.
	${MAKE} build
	PYTHONWARNINGS=all $(PYTHON) setup.py develop $(INSTALL_OPTS)
	rm -rf tmp

uninstall:  ## Uninstall this package via pip.
	cd ..; $(PYTHON) -m pip uninstall -y -v psutil

install-pip:  ## Install pip (no-op if already installed).
	$(PYTHON) -c \
		"import sys, ssl, os, pkgutil, tempfile, atexit; \
		sys.exit(0) if pkgutil.find_loader('pip') else None; \
		pyexc = 'from urllib.request import urlopen' if sys.version_info[0] == 3 else 'from urllib2 import urlopen'; \
		exec(pyexc); \
		ctx = ssl._create_unverified_context() if hasattr(ssl, '_create_unverified_context') else None; \
		kw = dict(context=ctx) if ctx else {}; \
		req = urlopen('https://bootstrap.pypa.io/get-pip.py', **kw); \
		data = req.read(); \
		f = tempfile.NamedTemporaryFile(suffix='.py'); \
		atexit.register(f.close); \
		f.write(data); \
		f.flush(); \
		print('downloaded %s' % f.name); \
		code = os.system('%s %s --user' % (sys.executable, f.name)); \
		f.close(); \
		sys.exit(code);"

setup-dev-env:  ## Install GIT hooks, pip, test deps (also upgrades them).
	${MAKE} install-git-hooks
	${MAKE} install-pip
	$(PYTHON) -m pip install $(INSTALL_OPTS) --upgrade pip
	$(PYTHON) -m pip install $(INSTALL_OPTS) --upgrade $(DEPS)

# ===================================================================
# Tests
# ===================================================================

test:  ## Run all tests.
	${MAKE} install
	$(TEST_PREFIX) $(PYTHON) $(TSCRIPT)

test-process:  ## Run process-related API tests.
	${MAKE} install
	$(TEST_PREFIX) $(PYTHON) -m unittest -v psutil.tests.test_process

test-system:  ## Run system-related API tests.
	${MAKE} install
	$(TEST_PREFIX) $(PYTHON) -m unittest -v psutil.tests.test_system

test-misc:  ## Run miscellaneous tests.
	${MAKE} install
	$(TEST_PREFIX) $(PYTHON) psutil/tests/test_misc.py

test-unicode:  ## Test APIs dealing with strings.
	${MAKE} install
	$(TEST_PREFIX) $(PYTHON) psutil/tests/test_unicode.py

test-contracts:  ## APIs sanity tests.
	${MAKE} install
	$(TEST_PREFIX) $(PYTHON) psutil/tests/test_contracts.py

test-connections:  ## Test net_connections() and Process.connections().
	${MAKE} install
	$(TEST_PREFIX) $(PYTHON) psutil/tests/test_connections.py

test-posix:  ## POSIX specific tests.
	${MAKE} install
	$(TEST_PREFIX) $(PYTHON) psutil/tests/test_posix.py

test-platform:  ## Run specific platform tests only.
	${MAKE} install
	$(TEST_PREFIX) $(PYTHON) psutil/tests/test_`$(PYTHON) -c 'import psutil; print([x.lower() for x in ("LINUX", "BSD", "OSX", "SUNOS", "WINDOWS", "AIX") if getattr(psutil, x)][0])'`.py

test-memleaks:  ## Memory leak tests.
	${MAKE} install
	$(TEST_PREFIX) $(PYTHON) psutil/tests/test_memory_leaks.py

test-by-name:  ## e.g. make test-by-name ARGS=psutil.tests.test_system.TestSystemAPIs
	${MAKE} install
	@$(TEST_PREFIX) $(PYTHON) -m unittest -v $(ARGS)

test-coverage:  ## Run test coverage.
	${MAKE} install
	# Note: coverage options are controlled by .coveragerc file
	rm -rf .coverage htmlcov
	$(TEST_PREFIX) $(PYTHON) -m coverage run $(TSCRIPT)
	$(PYTHON) -m coverage report
	@echo "writing results to htmlcov/index.html"
	$(PYTHON) -m coverage html
	$(PYTHON) -m webbrowser -t htmlcov/index.html

# ===================================================================
# Linters
# ===================================================================

pep8:  ## PEP8 linter.
	@git ls-files | grep \\.py$ | xargs $(PYTHON) -m pep8

pyflakes:  ## Pyflakes linter.
	@export PYFLAKES_NODOCTEST=1 && \
		git ls-files | grep \\.py$ | xargs $(PYTHON) -m pyflakes

flake8:  ## flake8 linter.
	@git ls-files | grep \\.py$ | xargs $(PYTHON) -m flake8

# ===================================================================
# GIT
# ===================================================================

git-tag-release:  ## Git-tag a new release.
	git tag -a release-`python -c "import setup; print(setup.get_version())"` -m `git rev-list HEAD --count`:`git rev-parse --short HEAD`
	git push --follow-tags

install-git-hooks:  ## Install GIT pre-commit hook.
	ln -sf ../../.git-pre-commit .git/hooks/pre-commit
	chmod +x .git/hooks/pre-commit

# ===================================================================
# Distribution
# ===================================================================

# --- create

sdist:  ## Create tar.gz source distribution.
	${MAKE} generate-manifest
	$(PYTHON) setup.py sdist

wheel:  ## Generate wheel.
	$(PYTHON) setup.py bdist_wheel

win-download-wheels:  ## Download wheels hosted on appveyor.
	$(TEST_PREFIX) $(PYTHON) scripts/internal/download_exes.py --user giampaolo --project psutil

# --- upload

upload-src:  ## Upload source tarball on https://pypi.python.org/pypi/psutil.
	${MAKE} sdist
	$(PYTHON) setup.py sdist upload

upload-win-wheels:  ## Upload wheels in dist/* directory on PYPI.
	$(PYTHON) -m twine upload dist/*.whl

# --- others

pre-release:  ## Check if we're ready to produce a new release.
	rm -rf dist
	${MAKE} install
	${MAKE} generate-manifest
	git diff MANIFEST.in > /dev/null  # ...otherwise 'git diff-index HEAD' will complain
	${MAKE} win-download-wheels
	${MAKE} sdist
	$(PYTHON) -c \
		"from psutil import __version__ as ver; \
		doc = open('docs/index.rst').read(); \
		history = open('HISTORY.rst').read(); \
		assert ver in doc, '%r not in docs/index.rst' % ver; \
		assert ver in history, '%r not in HISTORY.rst' % ver; \
		assert 'XXXX' not in history, 'XXXX in HISTORY.rst';"
	$(PYTHON) -c "import subprocess, sys; out = subprocess.check_output('git diff --quiet && git diff --cached --quiet', shell=True).strip(); sys.exit('there are uncommitted changes:\n%s' % out) if out else 0 ;"

release:  ## Create a release (down/uploads tar.gz, wheels, git tag release).
	${MAKE} pre-release
	$(PYTHON) -m twine upload dist/*  # upload tar.gz and Windows wheels on PYPI
	${MAKE} git-tag-release

print-announce:  ## Print announce of new release.
	@$(TEST_PREFIX) $(PYTHON) scripts/internal/print_announce.py

print-timeline:  ## Print releases' timeline.
	@$(TEST_PREFIX) $(PYTHON) scripts/internal/print_timeline.py

check-manifest:  ## Inspect MANIFEST.in file.
	$(PYTHON) -m check_manifest -v $(ARGS)

generate-manifest:  ## Generates MANIFEST.in file.
	$(PYTHON) scripts/internal/generate_manifest.py > MANIFEST.in

# ===================================================================
# Misc
# ===================================================================

grep-todos:  ## Look for TODOs in the source files.
	git grep -EIn "TODO|FIXME|XXX"

bench-oneshot:  ## Benchmarks for oneshot() ctx manager (see #799).
	${MAKE} install
	$(TEST_PREFIX) $(PYTHON) scripts/internal/bench_oneshot.py

bench-oneshot-2:  ## Same as above but using perf module (supposed to be more precise)
	${MAKE} install
	$(TEST_PREFIX) $(PYTHON) scripts/internal/bench_oneshot_2.py

check-broken-links:  ## Look for broken links in source files.
		git ls-files | xargs $(PYTHON) -Wa scripts/internal/check_broken_links.py

help: ## Display callable targets.
	@grep -E '^[a-zA-Z_-]+:.*?## .*$$' $(MAKEFILE_LIST) | sort | awk 'BEGIN {FS = ":.*?## "}; {printf "\033[36m%-20s\033[0m %s\n", $$1, $$2}'

=== third_party/python/slugid/requirements.txt ===
tox
twine

## mozjs60 60.1.0

=== debian/changelog ===
mozjs60 (60.1.0-1) unstable; urgency=medium

  * Team upload
  * New upstream release branch, required by gjs 1.53.90+
    (Closes: #904991)
    - Adapt mozjs52 packaging for major version 60
    - This is a new, parallel source package because the latest upstream
      versions of cjs and policykit-1 currently still require mozjs52
  * Refresh patch series
    - d/p/disable-mozglue.patch:
      Drop, appears to be unnecessary now
    - d/p/Fix-crashes-in-AtomicOperations-none.patch:
      Drop, unknown architectures compiled on gcc/clang now use
      js/src/jit/none/AtomicOperations-feeling-lucky.h which appears
      equivalent to the previous sparc/powerpc implementations
    - d/p/alpha-ia64-python-build-fixes.patch, d/p/sparc64-support.patch:
      Drop, appears to have been applied upstream
    - d/p/Don-t-include-xlocale.patch:
      Drop, appears to be unnecessary now
    - d/p/sh4-support.patch, d/p/m68k-support.patch:
      Drop, partially obsoleted by use of
      AtomicOperations-feeling-lucky.h; remaining changes need rebasing
      and re-testing (see #905833 for sh4, #905834 for m68k)
  * Build with srcdir != builddir. This matches the behaviour of GNOME's
    various continuous integration systems, and avoids a FTBFS when
    srcdir = builddir.
  * Explicitly disable jemalloc, which is broken in standalone mozjs
    releases and causes a trivial embedder to segfault. Again, this
    matches the "packaging" in GNOME's continuous integration.
    See https://bugzilla.mozilla.org/show_bug.cgi?id=1465038
  * d/p/Always-use-the-equivalent-year-to-determine-the-time-zone.patch:
    Apply patch from upstream (Firefox 62) to fix a test failure
    involving daylight saving variants of timezone names
  * d/test.sh: Update architectures where tests are expected to fail
    (Closes: #905199)
    - Remove ppc64el: tests now pass and #878319 has been closed
    - Add alpha: expected to fail due to #905825
    - Add sparc64: expected to fail due to #905825 and #905829
    - Update bug reference for m68k to #905830
  * Standards-Version: 4.2.0
  * d/source/lintian-overrides: Override warnings about long lines in
    some test files

 -- Simon McVittie <smcv@debian.org>  Thu, 16 Aug 2018 08:00:48 +0100

mozjs52 (52.9.1-1) unstable; urgency=medium

  * Team upload
  * New upstream release
    - CVE-2017-7810, CVE-2017-7826, CVE-2018-5089, CVE-2018-5125,
      CVE-2018-5150
  * d/p/remove-nspr-dependency.patch,
    d/p/tests-skip-on-all-64-bit-archs.patch:
    Remove, applied upstream
  * d/p/include-configure-script.patch:
    Remove, no longer necessary
  * d/rules: Drop configure options that no longer do anything
    - --enable-tests
    - --enable-threadsafe
    - --enable-xterm-updates
    - --enable-shared-js
    - --enable-gcgenerational
  * d/p/m68k-support.path:
    Update patch from John Paul Adrian Glaubitz to add missing m68k
    support in build/moz.configure/init.configure (Closes: #903483)
  * d/test.sh: Ignore test suite failure on m68k for now

 -- Simon McVittie <smcv@debian.org>  Wed, 01 Aug 2018 08:22:02 +0100

mozjs52 (52.3.1-9) unstable; urgency=medium

  * d/p/Disable-js-JIT-on-x32.patch, d/p/hppa-support.patch:
    Remove patches that are no longer listed in d/p/series
  * d/p/*.patch: Use gbp-pq style for metadata
  * d/p/Add-disable-layoutex-when-running-ICU-configure.patch:
    Explicitly disable Paragraph Layout support in bundled ICU. The
    bundled copy of ICU doesn't have the code for this optional feature,
    even if we find the icu-le-hb library during configure. In versions
    of mozjs52 compiled before Debian had icu-le-hb available, we didn't
    try to build that feature, so not having it is not a regression.
    Patch from Mike Hommey, via mozilla-unified. (Closes: #902197)
  * d/p/ia64-support.patch:
    Fix IA64 patch so it doesn't leave ReserveProcessExecutableMemory()
    returning an undefined result on !ia64 machines (Closes: #902961)
  * Standards-Version: 4.1.5 (no changes required)
  * Set Rules-Requires-Root to no
  * Regenerate js/src/old-configure with autoconf2.13 during build
    - d/p/pre-generate-old-configure.patch,
      d/p/Patch-pregenerated-old-configure-to-match-build-autoconf-.patch:
      Drop patches, no longer needed
  * Regenerate intl/icu/source/configure with autoreconf during build
  * d/rules: Delete all *.pyc files during clean
  * d/copyright: Move "Files: *" paragraph to the top as suggested by
    lintian

 -- Simon McVittie <smcv@debian.org>  Tue, 10 Jul 2018 12:33:30 +0100

mozjs52 (52.3.1-8) unstable; urgency=medium

  [ Jeremy Bicha ]
  * Update Vcs fields for migration to https://salsa.debian.org/
  * Update debian/gbp.conf

  [ John Paul Adrian Glaubitz ]
  * Add patch to fix Python build issues on alpha and ia64:
    - alpha-ia64-python-build-fixes.patch (Closes: #879589, #887496)
  * Add patch to add build support for sh4:
    - sh4-support.patch (Closes: #880692)
  * Disable PIE on sh4
  * Refresh patch for build support for m68k:
    - m68k-support.patch (Closes: #880693)
  * Add patch to add build support for sparc64:
    - sparc64-support.patch (Closes: #887494)
  * Ignore testsuite failures on ia64 (Closes: #897117)
  * Add patch to add build support for ia64:
    - ia64-support.patch (Closes: #897178)

 -- Jeremy Bicha <jbicha@debian.org>  Wed, 30 May 2018 12:01:49 -0400

mozjs52 (52.3.1-7) unstable; urgency=medium

  [ Adrian Bunk ]
  * Add tests-snans-be.patch:
    - Fix sort_snans.js test on big endian (Closes: #878285)

 -- Jeremy Bicha <jbicha@debian.org>  Fri, 20 Oct 2017 13:12:58 -0400

mozjs52 (52.3.1-6) unstable; urgency=medium

  [ Adrian Bunk ]
  * Disable ion JIT on mips (Closes: #878519, #878284)
  * Rename Fix-crashes-in-AtomicOperations-none-on-s390x.patch to
    Fix-crashes-in-AtomicOperations-none.patch and modify it to
    always use AtomicOperations-sparc.h instead of AtomicOperations-none.h
  * Add tests-increase-timeout.patch:


=== debian/control ===
# This file is autogenerated. DO NOT EDIT!
#
# Modifications should be made to debian/control.in instead.
# This file is regenerated automatically in the clean target.
Source: mozjs60
Section: libs
Priority: optional
Maintainer: Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>
Uploaders: Iain Lane <laney@debian.org>, Jeremy Bicha <jbicha@debian.org>, Tim Lunn <tim@feathertop.org>
Build-Depends: debhelper (>= 10.3),
               gnome-pkg-tools,
               autoconf,
               autoconf2.13,
               automake,
               libicu-dev,
               libreadline-dev,
               zlib1g-dev (>= 1:1.2.3),
               pkg-config,
               pkg-kde-tools,
               python-dev,
               zip
Rules-Requires-Root: no
Standards-Version: 4.2.0
Vcs-Browser: https://salsa.debian.org/gnome-team/mozjs60
Vcs-Git: https://salsa.debian.org/gnome-team/mozjs60.git
Homepage: https://developer.mozilla.org/en-US/docs/Mozilla/Projects/SpiderMonkey

Package: libmozjs-60-0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: SpiderMonkey JavaScript library
 SpiderMonkey is the code-name for Mozilla Firefox's C++ implementation of
 JavaScript. It is intended to be embedded in other applications
 that provide host environments for JavaScript.

Package: libmozjs-60-dev
Architecture: any
Section: libdevel
Depends: libmozjs-60-0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: SpiderMonkey JavaScript library - development headers
 SpiderMonkey is the code-name for Mozilla Firefox's C++ implementation of
 JavaScript. It is intended to be embedded in other applications
 that provide host environments for JavaScript.
 .
 This package contains the header files which are
 needed for developing SpiderMonkey embedders.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_ARCH  ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_ARCH_ENDIAN ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_ENDIAN)
# mozjs' build process does not seem to be compatible with other shells
# like zsh
export SHELL = /bin/sh
export PYTHON = python

SRCDIR = $(CURDIR)/js/src
BUILDDIR = $(CURDIR)/debian/build
CONFIGURE_FLAGS =

# ia64 currently has toolchain issues, so relax the link optimization
# -fno-schedule-insns2 breaks gcc on ia64, so leave it enabled
ifneq (,$(findstring $(DEB_BUILD_ARCH),ia64))
	DEB_CFLAGS_MAINT_APPEND += -G0 -fno-lifetime-dse -fno-delete-null-pointer-checks
	DEB_CXXFLAGS_MAINT_APPEND += -G0 -fno-lifetime-dse -fno-delete-null-pointer-checks
else
	DEB_CFLAGS_MAINT_APPEND += -fno-schedule-insns2 -fno-lifetime-dse -fno-delete-null-pointer-checks
	DEB_CXXFLAGS_MAINT_APPEND += -fno-schedule-insns2 -fno-lifetime-dse -fno-delete-null-pointer-checks
endif
ifneq (,$(findstring $(DEB_BUILD_ARCH),armel armhf))
        DEB_CFLAGS_MAINT_APPEND += -fno-schedule-insns
        DEB_CXXFLAGS_MAINT_APPEND += -fno-schedule-insns
endif
export DEB_CFLAGS_MAINT_APPEND DEB_CXXFLAGS_MAINT_APPEND

ifeq ($(DEB_HOST_ARCH),mips)
CONFIGURE_FLAGS += --disable-ion
endif

ifeq ($(DEB_HOST_ARCH),sh4)
CONFIGURE_FLAGS += --disable-pie
else
CONFIGURE_FLAGS += --enable-pie
endif

ifeq ($(DEB_HOST_ARCH_ENDIAN),little)
ICU_DATA_FILE = icudt60l.dat
else
ICU_DATA_FILE = icudt60b.dat
endif
export ICU_DATA_FILE

%:
	dh $@ --sourcedirectory=$(SRCDIR) --builddirectory=$(BUILDDIR) --with gnome,pkgkde-symbolshelper

override_dh_clean:
	dh_clean
	find $(CURDIR) -name \*.pyc -exec rm {} \;
	find $(CURDIR)/js/src/ -type l -exec rm {} \;
	rm -f $(CURDIR)/js/src/config/nsinstall
	rm -f $(CURDIR)/js/src/dist/bin/.purgecaches
	rm -f  $(CURDIR)/js/src/js60-config $(CURDIR)/js/src/mozjs-60.pc \
		$(CURDIR)/js/src/symverscript
	rm -f $(CURDIR)/js/src/config.log
	# rm -f $(CURDIR)/js/src/configure
	rm -fr $(CURDIR)/intl/icu/source/autom4te.cache
	rm -fr $(CURDIR)/debian/build

override_dh_autoreconf:
	dh_autoreconf $(CURDIR)/debian/autogen.sh

# dh_auto_configure does not properly handle autoconf2.13 generated configure
# scripts, so we call configure ourselves.
# http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=570375
# The bundled copy of icu prefers clang, which we need to override to
# use gcc because clang doesn't support our DEB_CFLAGS_MAINT_APPEND
override_dh_auto_configure:
	CC=$${CC:-$(DEB_HOST_GNU_TYPE)-gcc} \
	CXX=$${CXX:-$(DEB_HOST_GNU_TYPE)-g++} \
	VERBOSE=1 python intl/icu_sources_data.py "$(CURDIR)"
	mkdir -p $(BUILDDIR)
	cd $(BUILDDIR) && $(SHELL) $(SRCDIR)/configure \
		--host=$(DEB_HOST_GNU_TYPE) \
		--target=$(DEB_BUILD_GNU_TYPE) \
		--prefix=/usr \
		--libdir=/usr/lib/${DEB_HOST_MULTIARCH}/ \
		--without-system-icu \
		--enable-posix-nspr-emulation \
		--with-system-zlib \
		--disable-strip \
		--with-intl-api \
		--enable-readline \
		--disable-optimize \
		--disable-jemalloc \
		$(CONFIGURE_FLAGS)

override_dh_install:
	# move library and create additional symlinks to standardize the file layout
	cd $(CURDIR)/debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}/ && \
		mv libjs_static.ajs libmozjs-60.a && \
		mv libmozjs-60.so libmozjs-60.so.0.0.0 && \
		ln -s libmozjs-60.so.0.0.0 libmozjs-60.so.0 && \
		ln -s libmozjs-60.so.0 libmozjs-60.so
	rm debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}/libmozjs-60.a
	dh_install

override_dh_missing:
	dh_missing --fail-missing

override_dh_fixperms:
	dh_fixperms
	chmod a-x $(CURDIR)/debian/libmozjs-60-dev/usr/lib/${DEB_HOST_MULTIARCH}/pkgconfig/mozjs-60.pc

override_dh_gnome:
	dh_gnome --no-gnome-versions

override_dh_auto_test:
	@:
ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	SRCDIR=${SRCDIR} BUILDDIR=${BUILDDIR} DEB_HOST_ARCH=${DEB_HOST_ARCH} $(CURDIR)/debian/test.sh
endif
endif

=== debian/watch ===
version=4
# As of August 2018, there is not an official release of SpiderMonkey 60
# This tarball was downloaded from
# http://ftp.gnome.org/pub/gnome/teams/releng/tarballs-needing-help/mozjs/
# Also try
# https://treeherder.mozilla.org/#/jobs?repo=mozilla-esr60&filter-searchStr=sm-tc
https://archive.mozilla.org/pub/spidermonkey/releases/(60\.[\d.]+)/ \
	mozjs-@ANY_VERSION@@ARCHIVE_EXT@

## mozjs60 60.2.1

=== debian/changelog ===
mozjs60 (60.2.1-1) unstable; urgency=medium

  * Team upload
  * New upstream release
    - d/copyright: Update
  * d/p/tests-Add-the-ability-to-skip-tests-according-to-dpkg-arc.patch:
    Add patch to allow tests to be skipped or marked as random (flaky) or
    fails (expected failure) according to dpkg-architecture variables
  * Build with system ICU library (Closes: #908554)
    - Leave the patches and workarounds in place, but gate them behind
      a WITH_SYSTEM_ICU Make variable, to facilitate backporting
      as mentioned on #878362
    - d/p/Skip-some-i18n-tests-because-we-are-now-using-system-ICU.patch:
      Skip tests that fail with the system ICU library
  * Don't ignore overall test results on any architecture. We can ignore
    individual failing tests instead.
  * d/p/tests-Use-DEB_HOST_ARCH_BITS-to-skip-some-tests-on-64-bit.patch:
    Generalize the previous
    d/p/tests-For-tests-that-are-skipped-on-64-bit-mips64-is-also.patch
    to skip the affected tests on every 64-bit architecture, including
    alpha and sparc64 (Closes: #905825)
  * d/p/tests-Expect-some-floating-point-tests-to-fail-on-i386.patch:
    Mark some floating point tests as expected to fail on any-i386 due to
    our use of the legacy i387 FPU, which has different rounding
    behaviour (Closes: #907363)
  * d/p/tests-Expect-a-test-to-fail-on-armel.patch:
    Expect a test involving floating-point NaN to fail on ARM softfloat
    (Closes: #908481)
  * d/p/Bug-1444303-MIPS-Fix-build-failures-after-Bug-1425580-par.patch,
    d/p/Bug-1444834-MIPS-Stubout-MacroAssembler-speculationBarrie.patch:
    Add patches from upstream via firefox-esr which hopefully fix FTBFS
    on mips64el
  * Disable JIT (ion) on mipsel and mips64el as well as mips.
    It appears that the patches above are only enough to compile, but
    not work, on mips64el (many tests fail). (Closes: #908486)
    - This also avoids a compile-time static assertion failure
      affecting mipsel (Closes: #908485)
  * Add another source-is-missing Lintian override
  * d/copyright: Remove more unused licenses
  * d/copyright: Add public domain license grants
  * d/watch: Update instructions for downloading upstream releases

 -- Simon McVittie <smcv@debian.org>  Thu, 20 Sep 2018 09:02:56 +0100

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
                autoconf,
                autoconf2.13,
                automake,
-               libicu-dev,
+               libicu-dev (>= 58.2),
                libreadline-dev,
                zlib1g-dev (>= 1:1.2.3),
                pkg-config,

=== debian/rules ===
--- 
+++ 
@@ -3,6 +3,10 @@
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
+
+# This can be disabled if the bundled icu overtakes the system version,
+# or for backporting
+WITH_SYSTEM_ICU = yes
 
 DEB_HOST_ARCH  ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
 DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
@@ -33,7 +37,7 @@
 endif
 export DEB_CFLAGS_MAINT_APPEND DEB_CXXFLAGS_MAINT_APPEND
 
-ifeq ($(DEB_HOST_ARCH),mips)
+ifneq (,$(findstring $(DEB_HOST_ARCH),mips mipsel mips64el))
 CONFIGURE_FLAGS += --disable-ion
 endif
 
@@ -43,12 +47,17 @@
 CONFIGURE_FLAGS += --enable-pie
 endif
 
+ifeq ($(WITH_SYSTEM_ICU),yes)
+CONFIGURE_FLAGS += --with-system-icu
+else
+CONFIGURE_FLAGS += --without-system-icu
 ifeq ($(DEB_HOST_ARCH_ENDIAN),little)
 ICU_DATA_FILE = icudt60l.dat
 else
 ICU_DATA_FILE = icudt60b.dat
 endif
 export ICU_DATA_FILE
+endif
 
 %:
 	dh $@ --sourcedirectory=$(SRCDIR) --builddirectory=$(BUILDDIR) --with gnome,pkgkde-symbolshelper
@@ -67,7 +76,7 @@
 	rm -fr $(CURDIR)/debian/build
 
 override_dh_autoreconf:
-	dh_autoreconf $(CURDIR)/debian/autogen.sh
+	WITH_SYSTEM_ICU=$(WITH_SYSTEM_ICU) dh_autoreconf $(CURDIR)/debian/autogen.sh
 
 # dh_auto_configure does not properly handle autoconf2.13 generated configure
 # scripts, so we call configure ourselves.
@@ -75,16 +84,17 @@
 # The bundled copy of icu prefers clang, which we need to override to
 # use gcc because clang doesn't support our DEB_CFLAGS_MAINT_APPEND
 override_dh_auto_configure:
+ifneq ($(WITH_SYSTEM_ICU),yes)
 	CC=$${CC:-$(DEB_HOST_GNU_TYPE)-gcc} \
 	CXX=$${CXX:-$(DEB_HOST_GNU_TYPE)-g++} \
 	VERBOSE=1 python intl/icu_sources_data.py "$(CURDIR)"
+endif
 	mkdir -p $(BUILDDIR)
 	cd $(BUILDDIR) && $(SHELL) $(SRCDIR)/configure \
 		--host=$(DEB_HOST_GNU_TYPE) \
 		--target=$(DEB_BUILD_GNU_TYPE) \
 		--prefix=/usr \
 		--libdir=/usr/lib/${DEB_HOST_MULTIARCH}/ \
-		--without-system-icu \
 		--enable-posix-nspr-emulation \
 		--with-system-zlib \
 		--disable-strip \

## mozjs60 60.2.3

=== debian/changelog ===
mozjs60 (60.2.3-3) unstable; urgency=medium

  * Team upload
  * Acknowledge NMU. Thanks to Julien Cristau. (Closes: #909536)
  * Upload to unstable

 -- Simon McVittie <smcv@debian.org>  Sat, 13 Apr 2019 19:40:04 +0100

mozjs60 (60.2.3-2.1) experimental; urgency=medium

  * Non-maintainer upload.
  * d/p/tests-Add-the-ability-to-skip-tests-according-to-dpkg-arc.patch:
    wait() our dpkg-architecture child so we don't confuse the test runner.
  * Import patch from bmo #1488552 to fix 64-bit BE
  * Clean up better.
  * Fix TypedArray on 64-bit BE.
  * Don't run non262/extensions/clone-errors.js on s390x, it crashes.
  * This should let us pass tests on s390x, thus closes: #909536.

 -- Julien Cristau <jcristau@debian.org>  Thu, 11 Apr 2019 14:19:55 +0200

mozjs60 (60.2.3-2) unstable; urgency=medium

  * Team upload
  * d/p/Update-to-ICU-61-Part-3-Update-tests.patch:
    Add patch from upstream bug 1445465 to make tests pass with system
    ICU versions >= 61 (Closes: #913776)
    - d/control: build-depend on icu 61

 -- Simon McVittie <smcv@debian.org>  Thu, 15 Nov 2018 08:10:24 +0000

mozjs60 (60.2.3-1) unstable; urgency=medium

  * Team upload

  [ John Paul Adrian Glaubitz ]
  * Work around gcc register allocator issues on sh4 by selecting
    alternative register allocator using -mlra (Closes: #909180)

  [ Simon McVittie ]
  * New upstream release
  * d/p/mips-Use-fallback-64-bit-atomic-ops-on-mips32-even-if-JIT.patch:
    Drop, applied upstream
  * d/p/tests-Expect-a-test-to-fail-on-big-endian.patch:
    Expect typedarray-arg-set-values-same-buffer-other-type.js to fail on
    big-endian architectures. It makes assumptions about little-endian
    float/double representation that do not hold on big-endian, and
    fails in the same way on at least mips, powerpc, ppc64 and s390x.
  * Standards-Version: 4.2.1 (no changes required)

 -- Simon McVittie <smcv@debian.org>  Fri, 05 Oct 2018 12:07:35 +0100

mozjs60 (60.2.1-2) unstable; urgency=medium

  * Team upload
  * d/p/mips-Use-fallback-64-bit-atomic-ops-on-mips32-even-if-JIT.patch:
    Add patch from Julien Cristau to avoid trying to use 8-bit lock-free
    atomic operations on 32-bit mips{,el} (they don't exist there)
    when the ION JIT is disabled (Closes: #908487)
  * d/p/tests-Add-the-ability-to-skip-tests-according-to-dpkg-arc.patch:
    Respect DEB_HOST_ARCH if cross-compiling

 -- Simon McVittie <smcv@debian.org>  Tue, 25 Sep 2018 09:01:54 +0100

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
                autoconf,
                autoconf2.13,
                automake,
-               libicu-dev (>= 58.2),
+               libicu-dev (>= 61.1),
                libreadline-dev,
                zlib1g-dev (>= 1:1.2.3),
                pkg-config,
@@ -20,7 +20,7 @@
                python-dev,
                zip
 Rules-Requires-Root: no
-Standards-Version: 4.2.0
+Standards-Version: 4.2.1
 Vcs-Browser: https://salsa.debian.org/gnome-team/mozjs60
 Vcs-Git: https://salsa.debian.org/gnome-team/mozjs60.git
 Homepage: https://developer.mozilla.org/en-US/docs/Mozilla/Projects/SpiderMonkey

=== debian/rules ===
--- 
+++ 
@@ -13,6 +13,7 @@
 DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 DEB_HOST_ARCH_ENDIAN ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_ENDIAN)
+export DEB_HOST_ARCH
 # mozjs' build process does not seem to be compatible with other shells
 # like zsh
 export SHELL = /bin/sh
@@ -34,6 +35,10 @@
 ifneq (,$(findstring $(DEB_BUILD_ARCH),armel armhf))
         DEB_CFLAGS_MAINT_APPEND += -fno-schedule-insns
         DEB_CXXFLAGS_MAINT_APPEND += -fno-schedule-insns
+endif
+ifneq (,$(findstring $(DEB_BUILD_ARCH),sh4))
+        DEB_CFLAGS_MAINT_APPEND += -mlra
+        DEB_CXXFLAGS_MAINT_APPEND += -mlra
 endif
 export DEB_CFLAGS_MAINT_APPEND DEB_CXXFLAGS_MAINT_APPEND
 
@@ -74,6 +79,7 @@
 	# rm -f $(CURDIR)/js/src/configure
 	rm -fr $(CURDIR)/intl/icu/source/autom4te.cache
 	rm -fr $(CURDIR)/debian/build
+	rm -rf third_party/python/psutil/build/ third_party/python/psutil/psutil/_*.so third_party/python/psutil/tmp/
 
 override_dh_autoreconf:
 	WITH_SYSTEM_ICU=$(WITH_SYSTEM_ICU) dh_autoreconf $(CURDIR)/debian/autogen.sh

=== debian/watch ===
version=4
# As of September 2018, there is not an official release of SpiderMonkey 60
# This tarball was downloaded from
# https://treeherder.mozilla.org/#/jobs?repo=mozilla-esr60&filter-searchStr=sm
# Also try
# http://ftp.gnome.org/pub/gnome/teams/releng/tarballs-needing-help/mozjs/
https://archive.mozilla.org/pub/spidermonkey/releases/(60\.[\d.]+)/ \
	mozjs-@ANY_VERSION@@ARCHIVE_EXT@

## mozjs60 60.8.0

=== debian/changelog ===
mozjs60 (60.8.0-2ubuntu5) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 Mar 2020 21:33:35 +0100

mozjs60 (60.8.0-2ubuntu4) focal; urgency=medium

  * Fix a test for ICU 65.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 23 Feb 2020 14:07:09 +0100

mozjs60 (60.8.0-2ubuntu2) focal; urgency=medium

  * debian/rules: don't use unversioned python binary

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 21 Feb 2020 21:47:03 +0000

mozjs60 (60.8.0-2ubuntu1) focal; urgency=medium

  * debian/control: don't use an unversioned python binary

 -- Sebastien Bacher <seb128@ubuntu.com>  Mon, 17 Feb 2020 16:17:46 +0100

mozjs60 (60.8.0-2build1) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 13 Feb 2020 09:03:12 +0100

mozjs60 (60.8.0-2) unstable; urgency=medium

  * Release to unstable

 -- Jeremy Bicha <jbicha@debian.org>  Tue, 01 Oct 2019 07:07:32 -0400

mozjs60 (60.8.0-1) experimental; urgency=medium

  [ Iain Lane ]
  * New upstream release (re-imported to respect Files-Excluded from
    debian/copyright).

  [ Philip Chimento ]
  * d/p: Manually refreshed patches due to style reformatting of Mozilla
    codebase having been applied upstream since the last update
  * d/p: Dropped tests-snans-be.patch, already applied upstream
  * d/p: Dropped Bug-1560064-Barrier-Set-MovableCellHasher-JSObject-visibi,
    already applied upstream
  * d/p: Added patches from https://bugzilla.mozilla.org/show_bug.cgi?id=1375074
    and https://bugzilla.mozilla.org/show_bug.cgi?id=1445907 to fix JIT
    crashes on aarch64, based on the suggestion in
    https://bugzilla.mozilla.org/show_bug.cgi?id=1527311 (LP: #1842927)

 -- Iain Lane <laney@debian.org>  Mon, 09 Sep 2019 16:05:19 +0100

mozjs60 (60.2.3-4) experimental; urgency=medium

  [ Marco Trevisan (Treviño) ]
  * d/p/Bug-1560064-Barrier-Set-MovableCellHasher-JSObject-visibi.patch:
    - Make js::MovableCellHasher<JSObject*>::* symbols visible under GCC
  * debian/patches: Refresh

  [ Iain Lane ]
  * Generate shlibs with a lower bound. 60.2.3-4 is introducing a new symbol.
    We need reverse-deps to have a dependency on this version if they have
    been built with it. After 60.2.3, generate shlibs with -VUpstream-Version,
    so that dependencies are generated in the form >= Upstream-Version. A
    symbols file would be better.
  * debian/control{,.in}: Add tzdata to Depends an B/uild-Depends. The tests
    use ICU and require that this is installed. If it's not, they fail with
    messages like "non262/Date/time-zones.js:41:5 Error: Assertion failed: got
    "Fri Jul 19 2002 16:10:55 GMT+0000", expected "Fri Jul 19 2002 16:10:55"
    GMT+0100" because they can't run in the specified timezones.

 -- Iain Lane <laney@debian.org>  Mon, 24 Jun 2019 17:50:53 +0100

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,8 @@
                zlib1g-dev (>= 1:1.2.3),
                pkg-config,
                pkg-kde-tools,
-               python-dev,
+               python-all-dev,
+               tzdata,
                zip
 Rules-Requires-Root: no
 Standards-Version: 4.2.1
@@ -28,7 +29,7 @@
 Package: libmozjs-60-0
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}, tzdata
 Description: SpiderMonkey JavaScript library
  SpiderMonkey is the code-name for Mozilla Firefox's C++ implementation of
  JavaScript. It is intended to be embedded in other applications

=== debian/rules ===
--- 
+++ 
@@ -1,5 +1,7 @@
 #!/usr/bin/make -f
 # -*- makefile -*-
+
+include /usr/share/dpkg/default.mk
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
@@ -8,16 +10,11 @@
 # or for backporting
 WITH_SYSTEM_ICU = yes
 
-DEB_HOST_ARCH  ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
-DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
-DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
-DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
-DEB_HOST_ARCH_ENDIAN ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_ENDIAN)
 export DEB_HOST_ARCH
 # mozjs' build process does not seem to be compatible with other shells
 # like zsh
 export SHELL = /bin/sh
-export PYTHON = python
+export PYTHON = python2
 
 SRCDIR = $(CURDIR)/js/src
 BUILDDIR = $(CURDIR)/debian/build
@@ -93,7 +90,7 @@
 ifneq ($(WITH_SYSTEM_ICU),yes)
 	CC=$${CC:-$(DEB_HOST_GNU_TYPE)-gcc} \
 	CXX=$${CXX:-$(DEB_HOST_GNU_TYPE)-g++} \
-	VERBOSE=1 python intl/icu_sources_data.py "$(CURDIR)"
+	VERBOSE=1 $(PYTHON) intl/icu_sources_data.py "$(CURDIR)"
 endif
 	mkdir -p $(BUILDDIR)
 	cd $(BUILDDIR) && $(SHELL) $(SRCDIR)/configure \
@@ -130,6 +127,13 @@
 override_dh_gnome:
 	dh_gnome --no-gnome-versions
 
+override_dh_makeshlibs:
+ifeq (yes, $(shell dpkg --compare-versions $(DEB_VERSION_UPSTREAM) gt 60.2.3 && echo yes))
+	dh_makeshlibs -VUpstream-Version
+else
+	dh_makeshlibs -V"libmozjs-60-0 (>= 60.2.3-4~)"
+endif
+
 override_dh_auto_test:
 	@:
 ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
